---------------------------------------------------
--                                               --
--     		Supply Fix by Cliffe_Snake     		 --
--                 June  2012                 	 --
--                 version 1.0                   --
--												 --
---------------------------------------------------   
function doubleArray(m,n,k)
    local array = {}
    for x = 0, m
		do array[x] = {}
        for y = 0, n do
            array[x][y] = k or 0
        end
    end
    return array
end

MAP=doubleArray(map("xsize"),map("ysize"),0)

b_p={} -- building parameters
b_p[9]=1000		-- supply
b_p[15]=1500 	-- super supply


addhook("startround","_start")
function _start(mode)
	MAP=doubleArray(map("xsize"),map("ysize"),0)
end

addhook("use","d_use")
function d_use(id,event,data,tx,ty)
	local t,h
	if event==150 then
		t=object(MAP[tx][ty],"type")
		h=b_p[t]-object(MAP[tx][ty],"health")
		if object(MAP[tx][ty],"player")==id then
			if t==9 then
				parse("killobject "..MAP[tx][ty])
				parse("spawnobject 9 "..tx.." "..ty.." 0 "..data.." "..player(id,"team").." "..id)	-- rot mode team player
			elseif t==15 then
				parse("killobject "..MAP[tx][ty])
				parse("spawnobject 15 "..tx.." "..ty.." 0 "..data.." "..player(id,"team").." "..id)
			end
			if h>0 then
				parse("explosion "..(tx*32+16).." "..(ty*32+16).." 1 "..h.." 0")	-- x y size dmg source
			end
		end
	end
	
end

addhook("build","_build")
function _build(id,tip,tx,ty,mode,objectid)		--on (effective) build
	MAP[tx][ty]=objectid
end

addhook("objectkill","_objectkill")
function _objectkill(id,player)
	MAP[object(id,"tilex")][object(id,"tiley")]=0
end








